close; clear

global phase_disp 
global x_curr y_curr x_mem y_mem h_txdsp h_mark n_mark a_mark 

phase_disp='phaselan';
h_mark=0; n_mark=0; n_circ=0; n_text=0; a_mark=0; n_gp=0; n_ga=0; n_NF=0;
h_gp=0; h_ga=0; h_NF=0;
CS=[];  CL=[]; K=[];
h_gt=[]; h_gopt=[]; h_noise=[]; h_l=[]; h_s=[]; h_gin=[]; h_gout=[];


position=get(0,'screensize');
xsize=position(3); ysize=position(4);
position(4)=.9*position(4);
position(3)=1.25*position(4);
position(1)=(xsize-position(3))/2; position(2)=(ysize-position(4))/2;

figNumber=figure( ...
        'Name','SMITH CHART', ...
        'MenuBar','none',...
        'NumberTitle','off', ...
        'NextPlot','new', ...
	'Visible','off', ...
	'Position',position, ...
	'Colormap',[],...
        'Pointer','Crosshair');
ax=axes('position',[0 .09 .85 .85],'xlim',[-1 1],'ylim',[-1 1],'visible','off');
axis equal

frm2=[.8 0 2 1];
uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frm2, ...
	'BackgroundColor',[0.5 0.5 0.5]);

% Coefficiente di riflessione
h_tg=uicontrol('style','text','position',[.82,.93,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','Magnitude, Phase','unit','normalized','backgroundcolor',[1 0 0]);
h_gval=uicontrol('style','edit','position',[.82,.88,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);


% Punto corrente
h_tc=uicontrol('style','text','position',[.82,.80,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','Current Point','unit','normalized','backgroundcolor',[.5 0 0]);
h_cval=uicontrol('style','edit','position',[.82,.75,.175,.05],'string', '0.000, 0.000' ,...
'unit','normalized','backgroundcolor',[1 1 1]);


% Punto in memoria
h_tm=uicontrol('style','text','position',[.82,.68,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','Memory Point','unit','normalized','backgroundcolor',[.5 0 0]);
h_mval=uicontrol('style','edit','position',[.82,.63,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);



% Delta Gamma
h_tdg=uicontrol('style','text','position',[.82,.55,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','Delta Gamma','unit','normalized','backgroundcolor',[0 0 1]);
h_dgval=uicontrol('style','edit','position',[.82,.5,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);

% Delta Impedenza
h_tdz=uicontrol('style','text','position',[.82,.45,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','Delta Z','unit','normalized','backgroundcolor',[0 0 1]);
h_dzval=uicontrol('style','edit','position',[.82,.4,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);

% Delta Ammettenza
h_tdy=uicontrol('style','text','position',[.82,.35,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','Delta Y','unit','normalized','backgroundcolor',[1 0 0]);
h_dyval=uicontrol('style','edit','position',[.82,.3,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);



% Impedenza
h_tz=uicontrol('style','text','position',[.82,.2,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','R + jX','unit','normalized','backgroundcolor',[1 0 1]);
h_zval=uicontrol('style','edit','position',[.82,.15,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);

% Ammettenza
h_ta=uicontrol('style','text','position',[.82,.1,.175,.05],'ForegroundColor',[1 1 1], ...
  'string','G + jB','unit','normalized','backgroundcolor',[1 0 1]);
h_aval=uicontrol('style','edit','position',[.82,.05,.175,.05],'string','0.000, 0.000',...
'unit','normalized','backgroundcolor',[1 1 1]);




h_cerc=cerchio(0,0,1,[1 1 1],1.5);
h_txdsp=text('position',[.5,1.1],'string','Phase: L/Lamda','fontsize',10,'color',[0 1 0]);


% h1_val=[h_tg h_tz h_ta h_tc h_tm h_tdg h_tdz h_tdy]; 
h2_val=[h_gval h_zval h_aval h_cval h_mval h_dgval h_dzval h_dyval];

set(figNumber,'windowbuttonmotionfcn', 'gcp(ax,h2_val);');

str_butt='if ~isempty(h_gt), delete(h_gt); h_gt=[]; end; if ~isempty(h_gopt), delete(h_gopt); h_gopt=[]; end; if ~isempty(h_noise), delete(h_noise); h_noise=[]; end; ';
str_butt=[str_butt 'if ~isempty(h_gin), delete(h_gin); h_gin=[]; end; if ~isempty(h_gout), delete(h_gout); h_gout=[]; end; gcurrp(ax,h2_val);'];

set(figNumber,'windowbuttondownfcn', str_butt);

uicontrol(figNumber,'Style','pushbutton','CallBack','putmark','Position',[0.01,.91,.075,.05],'Units','normalized','String','Marker');
uicontrol(figNumber,'Style','pushbutton','CallBack','putmem(ax,h2_val)','Position',[0.01,.84,.075,.05],'Units','normalized','String','Store');
uicontrol(figNumber,'Style','pushbutton','CallBack','orient landscape; print;','Position',[0.01,.77,.075,.05],'Units','normalized','String','Print');

% Menu

h1=uimenu('label','Current Point'); 
  h11=uimenu(h1,'label','Coordinates');
	h111=uimenu(h11,'label','Gamma');
	   h1111=uimenu(h111,'label','Degree','Callback','getdeg');
	   h1112=uimenu(h111,'label','Lamda','Callback','getland');
	h112=uimenu(h11,'label','ROS');
	   h1121=uimenu(h112,'label','Degree','Callback','getRdeg');
	   h1122=uimenu(h112,'label','Lamda','Callback','getRland');
	h113=uimenu(h11,'label','Znorm','Callback','getznorm');
	h114=uimenu(h11,'label','Ynorm','Callback','getynorm');
  h13=uimenu(h1,'label','Memory','Callback','x_curr=x_mem; y_curr=y_mem; dispcp(ax,h2_val)');

h2=uimenu('label','Clear');
  h21=uimenu(h2,'label','Marker');
    h211=uimenu(h21,'label','All','Callback','if n_mark ~= 0,  delete(h_mark(1:n_mark)); h_mark=0; n_mark=0; end');
    h212=uimenu(h21,'label','Last','Callback','if n_mark ~= 0, delete(h_mark(n_mark)); n_mark=n_mark-1; end');
  h22=uimenu(h2,'label','Circles');
    h221=uimenu(h22,'label','All','Callback','if n_circ ~= 0, delete(h_circ(1:n_circ));  h_circ=0; n_circ=0; end');
    h222=uimenu(h22,'label','Last','Callback','if n_circ ~= 0, delete(h_circ(n_circ)); n_circ=n_circ-1; end');
  h23=uimenu(h2,'label','Text');
    h231=uimenu(h23,'label','All','Callback','if n_text ~= 0, delete(h_text(1:n_text)); h_text=0; n_text=0; end');
    h232=uimenu(h23,'label','Last','Callback','if n_text ~= 0, delete(h_text(n_text)); n_text=n_text-1; end');
  h24=uimenu(h2,'label','Sability Load','Callback','if ~isempty(h_l), delete(h_l); h_l=[]; end');
  h25=uimenu(h2,'label','Sability Generator','Callback','if ~isempty(h_s), delete(h_s); h_s=[]; end');
  h26=uimenu(h2,'label','Power Gain');
    h261=uimenu(h26,'label','All','Callback','if n_gp ~= 0, delete(h_gp(1:n_gp));  h_gp=0; n_gp=0; end');
    h262=uimenu(h26,'label','Last','Callback','if n_gp ~= 0, delete(h_gp(n_gp)); n_gp=n_gp-1; end');
  h27=uimenu(h2,'label','Available Gain');
    h271=uimenu(h27,'label','All','Callback','if n_ga ~= 0, delete(h_ga(1:n_ga));  h_ga=0; n_ga=0; end');
    h272=uimenu(h27,'label','Last','Callback','if n_ga ~= 0, delete(h_ga(n_ga)); n_ga=n_ga-1; end');
  h28=uimenu(h2,'label','Noise Figure');
    h281=uimenu(h28,'label','All','Callback','if n_NF ~= 0,  delete(h_NF(1:n_NF)); h_NF=0; n_NF=0; end');
    h282=uimenu(h28,'label','Last','Callback','if n_NF ~= 0, delete(h_NF(n_NF)); n_NF=n_NF-1; end');
  h29=uimenu(h2,'label','ALL (Reset)','Callback','cleall');
 

h3=uimenu('label','Increment');
  h31=uimenu(h3,'label','Phase (Deg)','Callback','getideg');
  h32=uimenu(h3,'label','Phase (Landa)','Callback','getilan');
  h33=uimenu(h3,'label','Resistance','Callback','getires');
  h34=uimenu(h3,'label','Reactance','Callback','getireac');
  h35=uimenu(h3,'label','Conductance','Callback','geticond');
  h36=uimenu(h3,'label','Susceptance','Callback','getisusc');

h4=uimenu('label','Display');
  h41=uimenu(h4,'label','Phase (Deg)','Callback','setdisp(ax,h2_val,''phasedeg'');');

  h42=uimenu(h4,'label','Phase (Landa)','Callback','setdisp(ax,h2_val,''phaselan'');');

h5=uimenu('label','Circles');
  h51=uimenu(h5,'label','Gamma');
    h511=uimenu(h51,'label','Value','Callback','circgaco');
    h512=uimenu(h51,'label','Current','Callback','circgamo'); 
  h52=uimenu(h5,'label','ROS');
    h521=uimenu(h52,'label','Value','Callback','circroco');
  h53=uimenu(h5,'label','Resistence');
    h531=uimenu(h53,'label','Value','Callback','circrco');
    h532=uimenu(h53,'label','Current','Callback','circrmo'); 
  h54=uimenu(h5,'label','Reactance');
    h541=uimenu(h54,'label','Value','Callback','circxco');
    h542=uimenu(h54,'label','Current','Callback','circxmo'); 
  h55=uimenu(h5,'label','Conductance');
    h551=uimenu(h55,'label','Value','Callback','circgco');
    h552=uimenu(h55,'label','Current','Callback','circgmo'); 
  h56=uimenu(h5,'label','Susceptance');
    h561=uimenu(h56,'label','Value','Callback','circbco');
    h562=uimenu(h56,'label','Current','Callback','circbmo'); 

h6=uimenu('label','Text','callback','getext');

h7=uimenu('label','AutoMark');
  h71=uimenu(h7,'label','ON','callback','autmark','enable','on');
  h72=uimenu(h7,'label','OFF','callback','autmark','enable','off');

h8=uimenu('label','S Param.');
  h81=uimenu(h8,'label','Get S Parameters');
    h811=uimenu(h81,'label','From file','callback','get_file');
    h812=uimenu(h81,'label','Change Frequency','callback','change_f');
    h813=uimenu(h81,'label','From keyboard','callback','get_keyb','enable','off');
  h82=uimenu(h8,'label','Stability circles');
    h821=uimenu(h82,'label','Generator','callback','if ~isempty(CS), h_s=cercfill(real(CS),imag(CS),rS,[1 1 0]); end');
    h822=uimenu(h82,'label','Load','callback','if ~isempty(CS), h_l=cercfill(real(CL),imag(CL),rL,[1 0 0]); end');
  h83=uimenu(h8,'label','Circles');
    h831=uimenu(h83,'label','Power Gain','Callback','c_power');
    h832=uimenu(h83,'label','Available Gain','Callback','c_avail');
    h833=uimenu(h83,'label','Noise','Callback','c_noise');
  h84=uimenu(h8,'label','Optimum Gamma');
    h841=uimenu(h84,'label','Source','Callback','disp_gp');
    h842=uimenu(h84,'label','Load','Callback','disp_ga');
  h85=uimenu(h8,'label','Gamma IN','Callback','disp_gin');
  h86=uimenu(h8,'label','Gamma OUT','Callback','disp_gou');

h9=uimenu('label','CLOSE','callback','close; clear; quit');

x_mem=0; y_mem=0; x_curr=0; y_curr=0;

set(figNumber,'visible','on');