% stamp_S.m

fig4=figure('Color',[.5 .5 .5],'MenuBar','none','Units','normal','visible', 'off');
set(fig4,'Position',[.25,.6,.6,.6],'NumberTitle','off'); 
ax2=axes('Position',[0,0,1,1],'Units','normalized','Visible','off');

s11m=abs(S(1,1)); s11f=180*angle(S(1,1))/pi;
s12m=abs(S(1,2)); s12f=180*angle(S(1,2))/pi;
s21m=20*log10(abs(S(2,1))); s21f=180*angle(S(2,1))/pi;
s22m=abs(S(2,2)); s22f=180*angle(S(2,2))/pi;

text('String',['Scattering Parameters at ' num2str(freq) ' ' unit_f],'Units','normalized','FontSize',11,'Position',[.2,.9]);
text('String',['S11 (Mag, Phase deg)   ' num2str(s11m) ' , ' num2str(s11f)],'Units','normalized','FontSize',11,'Position',[.05,.85]);
text('String',['S12 (Mag, Phase deg)   ' num2str(s12m) ' , ' num2str(s12f)],'Units','normalized','FontSize',11,'Position',[.05,.8]);
text('String',['S21 (dB,  Phase deg)   ' num2str(s21m) ' , ' num2str(s21f)],'Units','normalized','FontSize',11,'Position',[.05,.75]);
text('String',['S22 (Mag, Phase deg)   ' num2str(s22m) ' , ' num2str(s22f)],'Units','normalized','FontSize',11,'Position',[.05,.7]);

if stab == 1,
GsmM=abs(Gsm); gsmP=180*angle(Gsm)/pi;
GlmM=abs(Glm); glmP=180*angle(Glm)/pi;
GdB=10*log10(Gtmax);
text('String','Unconditionally STABLE','Units','normalized','FontSize',11,'Position',[.05,.6]);
text('String',['Stability Coefficient K: ' num2str(K)],'Units','normalized','FontSize',11,'Position',[.05,.55]);
text('String',['Optimum Gamma Source (Mag, Phase deg): ' num2str(GsmM) ' , ' num2str(gsmP)],'Units','normalized','FontSize',11,'Position',[.05,.5]);
text('String',['Optimum Gamma Load   (Mag, Phase deg): ' num2str(GlmM) ' , ' num2str(glmP)],'Units','normalized','FontSize',11,'Position',[.05,.45]);
text('String',['Maximum Transducer Gain (dB): ' num2str(GdB)],'Units','normalized','FontSize',11,'Position',[.05,.4]);
else
msgdb=10*log10(MSG);
text('String','Potentially INSTABLE','Units','normalized','FontSize',11,'Position',[.05,.6]);
text('String',['Maximum Stable Gain (dB): ' num2str(msgdb)],'Units','normalized','FontSize',11,'Position',[.05,.55]);
text('String',['Stability Coefficient K: ' num2str(K)],'Units','normalized','FontSize',11,'Position',[.05,.5]);
end

if ~ isempty(nnoise);
 if noise(1) <= freq & noise(nnoise) >= freq,
g1=abs(Gnf); g2=180*angle(Gnf)/pi;
text('String',['Noise Parameters at ' num2str(freq) ' ' unit_f],'Units','normalized','FontSize',11,'Position',[.2,.3]);
text('String',['Minimum Noise Figure (dB): ' num2str(NFmindB)],'Units','normalized','FontSize',11,'Position',[.05,.25]);
text('String',['Optimum Gamma Source (Mag, Phase deg): ' num2str(g1) ' , ' num2str(g2)],'Units','normalized','FontSize',11,'Position',[.05,.2]);
text('String',['Normalized Noise Resistance: ' num2str(rn)],'Units','normalized','FontSize',11,'Position',[.05,.15]);
end
end

pl4=uicontrol('Style','pushbutton','CallBack','close(fig4); clear fig4 pl4;','Position',[0.65,.03,.3,.075],'Units','normalized','String','Continue');

set(fig4,'visible', 'on');


